﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class Personagem : MonoBehaviour {
	int ContadorPulos;
	float Vx; 	//velocidade em x
	float Vy;	//velocidade em y
	float VelocidadeHorizontal;
	float VelocidadePular;
	float VelocidadeProjetil;
	float DirecaoHorizontal; 
	float DirecaoDisparo;
	Rigidbody2D CorpoRigido; //corpo rígido do elemento onde o script foi inserido.
	bool PodeDisparar;
	float TempoEntreDisparos;

	void Start () {
		DirecaoDisparo = 1;
		DirecaoHorizontal = 0;
		ContadorPulos = 0;
		VelocidadeHorizontal = 5;	//incia a velocidade de andar na horizontal(direita e esquerda)
		VelocidadePular	= 5;		//inicia a velocidade de pular
		VelocidadeProjetil=10;
		TempoEntreDisparos = 2;
		PodeDisparar = true;
		CorpoRigido = GetComponent<Rigidbody2D> ();		//recupera o corpo rigido inserido no elemento que possui o script(corpo rígido do personagem)
		CorpoRigido.freezeRotation = true;				//impede que rotacione no eixo.	
	}
	void Update () {
		MovimentoHorizontal();
		PuloDuplo();
		LancarProjetil1();
		LancarProjetil2 ();
	}
	void PuloDuplo(){
		if (Input.GetButtonDown ("Jump") == true &&  ContadorPulos < 2 ) {
			ContadorPulos = ContadorPulos+1;
			VelocidadeHorizontal = VelocidadeHorizontal / 2;
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}
	void LancarProjetil1(){
		if (Input.GetKeyDown (KeyCode.LeftShift) == true) {
			//procura o elemento que foi configurado com a tag projetil2
			GameObject projetil = GameObject.FindGameObjectWithTag ("projetil2");
			//cria uma cópia do objeto de jogo projetil, é uma copia do "tiro"
			GameObject copiaProjetil = Instantiate (projetil);
			//recupera a posiçao do personagem
			//a copia do projetil deve ser posicionada na posicao do personagem
			float xPersonagem = gameObject.transform.position.x;
			float yPersonagem = gameObject.transform.position.y;
			//posiciona a copia na mesma posição do personagem.
			//soma + 0,5 em x, para não ficar exatamente na personagem
			if (DirecaoDisparo == 1) {
				//+1 para não ficar exatamente sobre o personagem
				copiaProjetil.transform.position = new Vector2 (xPersonagem + 1f, yPersonagem);
			}else{
				//-1 para não ficar exatamente sobre o personagem
				copiaProjetil.transform.position = new Vector2 (xPersonagem - 1f, yPersonagem);
			}
			//recupera o corpo rigido da cópia
			Rigidbody2D corpoRigidoCopia = copiaProjetil.GetComponent<Rigidbody2D> ();
			corpoRigidoCopia.velocity = new Vector2 (VelocidadeProjetil*DirecaoDisparo, 0);
			Destroy (copiaProjetil, 3.5f);
		}
	}

	void LancarProjetil2(){
		if (Input.GetKey (KeyCode.LeftControl) == true &&  PodeDisparar==true) {
			PodeDisparar = false;
			//chama o método que troca PodeDisparar para verdadeiro em um determinado tempo
			Invoke ("AtivarDisparo", TempoEntreDisparos);
			GameObject projetil = GameObject.FindGameObjectWithTag ("projetil");
			//cria uma cópia do projetil
			GameObject copiaProjetil = Instantiate (projetil);
			//recupera o corpo rigido da cópia
			Rigidbody2D corpoRigidoCopia = copiaProjetil.GetComponent<Rigidbody2D> ();
			float xPersonagem = gameObject.transform.position.x;
			float yPersonagem = gameObject.transform.position.y;
			//posiciona a copia na mesma posição do personagem.
			//soma + 0,5 em x, para não ficar exatamente na personagem
			if (DirecaoDisparo == 1) {
				copiaProjetil.transform.position = new Vector2 (xPersonagem + 1f, yPersonagem);
			}else{
				copiaProjetil.transform.position = new Vector2 (xPersonagem - 1f, yPersonagem);
			}
			corpoRigidoCopia.velocity = new Vector2 (VelocidadeProjetil*DirecaoDisparo, 0);
			Destroy (copiaProjetil, 3.5f);
		}
	}

	void MovimentoHorizontal(){
		//DirecaoHorizontal Recebe até 1 quando precionado o botão para direita e até -1 para esquerda. Quando parado Recebe 0.
		DirecaoHorizontal = Input.GetAxis ("Horizontal");
		// Gera uma nova velocidade em x
		Vx = VelocidadeHorizontal * DirecaoHorizontal;
		//Recupera a velocidade em y que o personagem já possui
		Vy = CorpoRigido.velocity.y;
		//Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		Vector2 andar = new Vector2 (Vx, Vy);
		// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem
		CorpoRigido.velocity = andar;

		if(DirecaoHorizontal>0){
			DirecaoDisparo = 1;
		}
		if (DirecaoHorizontal < 0) {
			DirecaoDisparo = -1;
		}
	}

	void OnCollisionEnter2D(Collision2D objetoTocado){
		string tagTocada = objetoTocado.gameObject.tag;
		if (tagTocada == "chao") {
			ContadorPulos = 0;
			VelocidadeHorizontal = 5;
		}
	}
	void AtivarDisparo(){
		PodeDisparar = true;
	}
}
